<?php

namespace app\admin\behavior;

/**
 * 系统行为扩展：
 */
class AppEndBehavior {
    protected static $actionName;
    protected static $controllerName;
    protected static $moduleName;

    /**
     * 构造方法
     * @param Request $request Request对象
     * @access public
     */
    public function __construct()
    {

    }

    // 行为扩展的执行入口必须是run
    public function run(&$params){
        self::$actionName = request()->action();
        self::$controllerName = request()->controller();
        self::$moduleName = request()->module();
        // file_put_contents ( DATA_PATH."log.txt", date ( "Y-m-d H:i:s" ) . "  " . var_export('admin_CoreProgramBehavior',true) . "\r\n", FILE_APPEND );
        $this->_initialize();
    }

    protected function _initialize() {
        $this->saveBaseFile();
        $this->renameInstall(); // 重命名安装目录
    }

    /**
     * 存储后台入口文件路径，比如：/login.php
     */
    protected function saveBaseFile()
    {
        if(!empty($_SESSION['isset_saveBaseFile']))
            return false;
        $_SESSION['isset_saveBaseFile'] = 1;
        /*在以下相应的控制器和操作名里执行，以便提高性能*/
        $ctlActArr = array(
            'Admin@login',
            'Index@index',
        );
        $ctlActStr = self::$controllerName.'@'.self::$actionName;
        if (in_array($ctlActStr, $ctlActArr)) {
            $baseFile = request()->baseFile();
            tpCache('web', array('web_adminbasefile'=>$baseFile));
        }
        /*--end*/
    }

    /**
     * 重命名安装目录，提高网站安全性
     */
    protected function renameInstall()
    {
        if ('GET' == request()->method()) {
            if(!empty($_SESSION['isset_renameInstall']))
                return false;
            $_SESSION['isset_renameInstall'] = 1;
            $install_path = ROOT_PATH.'install';
            if (is_dir($install_path) && file_exists($install_path)) {
                $install_time = DEFAULT_INSTALL_DATE;
                $constsant_path = APP_PATH.MODULE_NAME.'/conf/constant.php';
                if (file_exists($constsant_path)) {
                    require_once($constsant_path);
                    defined('INSTALL_DATE') && $install_time = INSTALL_DATE;
                }
                $new_path = ROOT_PATH.'install_'.$install_time;
                @rename($install_path, $new_path);
                @unlink($new_path.DS.'install.lock');
            }
        }
    }
}
